/* ************************************************************************************
 *	Das Modul beinhaltet Variablendeklarationen sowie Definitionen und
 *  Initialisierungswerte. Dasselbe gilt fr Objekte der Ein- und Ausgabe.
 *	Die Datei ist nicht in der allgemeinen Bibliothek gespeichert, sondern
 *	lokal bei der HTML-Seite des Programms.
 *
 *	The module contains variable declarations as well as definitions and
 *  Initialization values.  The same applies to objects of input and output.
 *	The file is not stored in the general library, but
 *	Locally at the HTML page of the program.
 *
 *
 *	Erstellt:	15.07.2021	Dieter Steffan
 *
 *********************************************************************************** */	

/* ***************** Variablen Deklarationen - Variable declarations ************************ */
				
var JD = 0.0;							// Das Julianische Datum eines Gregorianischen Datums
												// The Julian date of a Gregorian date
var newmoon = 0.0;					// Wert fr den Neumond als Jul. Datum
												// Value for the new moon as Jul.  Date
var fullmoon = 0.0;					// Wert fr den Vollmond als Jul. Datum
												// Value for the full moon as Jul.  Date
var GDayFullMoon = 0.0;			// Der Greenwich Tag des Vollmonds als Dezimalwert 
												// The Greenwich Day of the Full Moon as a Decimal Value
var GDayFullMoonInt = 0;		// Der Greenwich Tag des Vollmonds als Integer
												// The Greenwich Day of the Full Moon as a integer
var GMonthFullMoonInt = 0;		// Der Greenwich Monat des Vollmonds als Integer
												// The Greenwich Month of the Full Moon as a integer
var GYearFullMoonInt = 0;		// Der Greenwich jahr des Vollmonds als Integer
												// The Greenwich Year of the Full Moon as a integer
var UTFullMoon = 0.0;				// Universal Zeit (UT) des Vollmonds
												// Universal time (UT) of the full moon
var LCTFullMoon = 0.0;			// Lokale Zeit (LCT) des Vollmonds
												// Local time (LCT) of the full moon
var LCTDayFullMoon = 0;		// Lokaler Tag (LCT) des Vollmonds
												// Local day (LCT) of the full moon
var LCTmonthFullMoon = 0;		// Lokaler Monat (LCT) des Vollmonds
												// Local month (LCT) of the full moon
var LCTYearFullMoon = 0;		// Lokales Jahr (LCT) des Vollmonds
												// Local year (LCT) of the full moon
var LCTTimeLocalFull = "";		// Lokale Zeit (hh:mm:ss.ms) des Vollmonds
												// Local time (hh:mm:ss.ms) of the full moon
var GDayNewMoon = 0.0;		// Der Greenwich Tag des Vollmonds als Dezimalwert 
												// The Greenwich Day of the New Moon as a Decimal Value
var GDayNewMoonInt = 0;		// Der Greenwich Tag des Vollmonds als Integer
												// The Greenwich Day of the New Moon as a integer
var GMonthNewMoonInt = 0;	// Der Greenwich Monat des Vollmonds als Integer
												// The Greenwich Month of the New Moon as a integer
var GYearNewMoonInt = 0;		// Der Greenwich jahr des Vollmonds als Integer
												// The Greenwich Year of the New Moon as a integer
var UTNewMoon = 0.0;				// Universal Zeit (UT) des Vollmonds
												// Universal time (UT) of the New moon
var LCTNewMoon = 0.0;			// Lokale Zeit (LCT) des Vollmonds
												// Local time (LCT) of the New moon
var LCTDayNewMoon = 0;		// Lokaler Tag (LCT) des Vollmonds
												// Local day (LCT) of the New moon
var LCTmonthNewMoon = 0;		// Lokaler Monat (LCT) des Vollmonds
												// Local month (LCT) of the New moon
var LCTYearNewMoon = 0;		// Lokales Jahr (LCT) des Vollmonds
												// Local year (LCT) of the New moon
var LCTTimeLocalNew = "";		// Lokale Zeit (hh:mm:ss.ms) des Vollmonds
												// Local time (hh:mm:ss.ms) of the New moon
												// Data of occulation at solar eclipse into an array
var s = "";									// Ergebnisstring - Result string
var stopIsClicked = false;			// Zeigt an, ob der Stop Button gedrckt wurde
var magSolar = new Array();	// Ergebnis Array der Magnitude der Sonne bei Finsternis
var w;										// Objekt des Background Workers (Multitasking)
var objChannel;						// Neuer Broadcast Kanal zur Kommunikation zu anderen Fenstern
var splitData1 = new Array();	// Array nimmt die gespliteten Daten vom Grafikfenster auf
var sendDataOutput = false;	// Zeigt an, das Grafikfenster Daten haben mchte
var startProgressTime = 0;		// Startzeit fr die Verarbeitungsdauer Ausgabe
var stopProgressTime = 0;		// Stopzeit fr die Verarbeitungsdauer Ausgabe
var diffProgressTime = 0;			// Die Zeitdifferenz der Verarbeitung Ausgabe
var DELAY = 0;						// Variable fr die zustzliche Wartezeit bei den Berechnungen Hauptprogramm
var DELAY1 = 0;						// Variable fr die zustzliche Wartezeit bei den Berechnungen Grafikfenster
var ISDST = 0;							// Zeigt Daylight savings time an
var newWindow = null;			// Zeigt an das das Ausgabefenster geffnet ist
var workData = new Array();	// Arrays fr die Aufsplitung der Sendedaten
var splitData = new Array();		//							"-"
var dialogOpen = undefined;		// Zeigt an ob das Dialogfenster offen ist
												// Shows whether the dialog is open
var goandwork = undefined;		// Zeigt an, ob der Bachgroundworker nach Dialog gestartet werden kann
var jdNewMn = 0.0;					// Julianisches Datum, das vom Aufruf an die Funktion showDialog()
												// bergeben wird und hier gespeichert werden muss, da sonst keine
												// Berechnungstattfindet
												// Julian date from the call to the function showDialog () 
												// is passed and must be saved here, otherwise no
												// Calculation takes place

/* ***************** Verwendete Objekte - Used objects ************************ */

// Datums Objekt fr das automatische Fllen
// Date Object for automatic filling
var d = new Date();			
// Objekt des Berechnen Buttons
// Object of the calculation button
var objCalc = document.getElementById("calc");	
// Objekt der Eingabe des zu berechnenden Jahres
// Object of entry of the year to be calculated
var objYear = document.getElementById("year");
// Objekt der Eingabe des zu berechnenden Monats
// Object of the input of the month to be calculated
var objMonth = document.getElementById("month");
// Objekt der Eingabe des zu berechnenden Tages
// Object of the input of the day to be calculated
var objDay = document.getElementById("day");
// Objekte der Ausgabefelder
// Objects of the output fields
//
// Objekt der Ausgabe des Julianisches Datum der Epoche 
// 2010 zum 0.1. 00:00:00:000
// Object of the issue of the Julian Date of the Epoch
// 2010 to 0. 1. 00:00:00:000
var objJD = document.getElementById("jd");
// Objekt der Ausgabe des Schaltjahres
// Object of the output of the leap year
var objLeapYear = document.getElementById("leapyear");
// Objekt der Ausgabe Julianischen Datum des Startdatum als Kontrolle
// Object of the edition Julian date of the start date to control
var objJD0 = document.getElementById("jd0");
// Objekt der HTML Seite body
// Object of the HTML page body
var objB = document.getElementById("b");
// Objekt der Textarea und Variable fr den Inhalt
// Object of the textarea and variable for the input of textarea
var objText = document.getElementById("t");
// Beendet die Berechnung bei Klick auf den Button "Stop"
var objStopCalc = document.getElementById("stopcalc");
// Texteingabebox Lngengrad Beobachtungsort
// Text input box Longitude of observation
var objLambda = document.getElementById("lambda");
// Texteingabebox Breitengrad Beobachtungsort
// Text input box Latitude of observation
var objBeta = document.getElementById("beta");
// Die Bedeckung der Sonnen/Mondfinsternis
// The magnitude of the sun/moon eclipse
var objMagnitude = document.getElementById("magnitude");
// Die Progressbar fr die Anzeige der verabeiteten Berechnungen
// The progressbar for displaying the processed calculations
var objSpeedbar = document.getElementById("speedbar");
var objProgressbar = document.getElementById("progressbar");
// Ausgabe der Berechnungszeit einer kompletten Berechnung in ms
// Output of the calculation time of a complete calculation in ms
var objCalcTime = document.getElementById("calctime");
// Eingabe der Schrittweite der Berechnung des Lngengrades
// Enter the step width of the calculation of the longitude
var objLongStep = document.getElementById("longstep");
// Eingabe der Schrittweite der Berechnung des Breitengrades
// Enter the step width of the latitude calculation
var objLatStep = document.getElementById("latstep");
// Ausgabe der Daylight savings time (DST) oder Sommer/Winterzeit
// Output of daylight savings time (DST) or summer/winter time
var objDST = document.getElementById("dst");
// Daten des Neumonds ungesplitted
// Data of the new moon unsplitted
var newMoonSplitted;
// Daten des Neumonds aufgesplitted
// Data of the new moon splitted
var arrNewMoonSplitted = new Array();
// String der Anzeigt, on ein Finsternis ist oder nicht
// String of the display, on is an eclipse or not
var occur = "";
// Daten Rckgabe Array fr die Lngengrade/Breitengrade/Bedeckung im Hauptprogramm
// Data Return Array for longitude/latitude/coverage in the main program
var retArray  = new Array();
// Objekte der Dialogfenster
// Object of dialog windows
//
// Dialog Objekte, Dialog selbst
// Dialog objects, Dialog itself
var dlg = document.getElementById("dialog");
// Dialog Objekt OK-Button
// dialog Object OK button
var okbutton = document.getElementById("okbutton");
// Dialog Objekt Cancel-Button
// Dialog Object cancel button
var cancelbutton = document.getElementById("cancelbutton");
// Button Dialog ffnen
// Button dialog open
var objBtn = document.getElementById("btn");
// Textfeld des Ergebnis
// Textfield for result
var objTxtResult = document.getElementById("txtResult");
// Textfeld der Message
// Textfield of the dialog message
var objTxt = document.getElementById("txt");
// Objekt des Div-Elements fr den abgeblendeten Hintergrund
// Object of the Div element for the faded background
var objTrans = document.getElementById("trans");
