/*  **********************************************************************************************************************************
 Die Javascript Datei stellt einen einfachen Background Worker fr die Multithreaded
 Programmierung zur Verfgung. Es handelt sich um eine eigene JS Datei, die ber das
 Haupprogramm initialisiert werden muss:
 
  **************************************************************************************************
 						// WebWorker erstellen, wenn er nicht vorhanden ist.
						//
						if(typeof(Worker)!=="undefined") {
						
							if(typeof(w)=="undefined") {
								
								// Neues WebWorker Objekt generiert aus der JavaScript Datei.
								// Achtung: Bei lokalen Dateien muss der Browser mit dem
								// Kommandline Parameter: "allow-file-access-from-files" gestartet
								// werden. Andernfalls unter einem Webserver starten.
								//
								w = new Worker("background_worker.js" );
								
							// Background Worker nicht terminiert ...
							}else{
								// Hier ist der Bachground Worker aktiv
							}		
							// Event Message Que ber die alle Daten vom WebWorker eintreffen.
							//
							w.onmessage = function (event) {
							
								workData = event.data.split("~");
								// ... danach durchlaufe das Array workData mit den key=value Paaren ...
								// ... then run through the array workData with the key=value pairs ...
								for(idx in workData){
									// ... und splitte diese anhand des Trenners "=" auf und lege sie im Array
									// splitData ab. Im Index 0 = key und Index 1 = Data ...
									// ...  and split them using the separator = and put them in the array
									// splitData ab.  In index 0 = key and index  1 = Data ...
									splitData = workData[idx].split("=");
									// ... schaue nun nach den Werten der Key's ...
									// ... hier das Julianische Datum des Neumondes und der Finsternis
									// ... look now for the values of the keys ...
									// ...  here the Julian date of the new moon and the darkness
									if (splitData[0] == "longitude"){
										lo = splitData[1];
									}else if (splitData[0] == "magnitude"){
										mg = splitData[1];
									}

								}// End of for (....)
								
							}// End of onmessage()
							
						// Der Browser kennt den WebWorker nicht und gibt eine Fehlermeldung aus.
						} else {
							alert("Entschuldigung, Ihr Browser untersttzt Multitasking mit Webworker nicht ...");
						}
 **************************************************************************************************

 Es ist ebnfalls sehr wichtig zu wissen, das die Ausfhrung des Programmes auf der lokalen Festplatte
 nicht so einfach funktioniert. Dazu muss der Browser mit folgendem Parameter, eingetragen unter "Ziel:"
 in den Eigenschaften des Browser Icons auf dem Desktop. 
 
 "C:\Program Files (x86)\Google\Chrome\Application\chrome.exe" --allow-file-access-from-files
 
 Wichtig ist der hintere Teil des Links : "--allow-file-access-from-files" dies erlaubt dem Browser auf 
 Dateien der Festplatte zuzugreifen. Beim Laden von einer Website ist dies nicht notwendig.
 
 Der Background Worker stellt alle Daten der Sonnenfinsternis und von Sonneauf- und Untergang
 zur Verfgung. Die Daten werden auf Anfrage des Hauptprogramms und des grafischen Ausgabefensters
 an diese syncron gesendet, damit beide die Daten parallel erhalten.
 
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
 The Javascript file provides a simple background worker for the multithreaded
  programming available.  It is a separate JS file, which can be accessed via the
  Main program must be initialized:
 
   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  						/ / Create WebWorker if it does not exist.
 						//
 						if (typeof (Worker)!==undefined)   {
						
 							if (typeof (w) ==undefined)   {
								
 								//  New WebWorker  Object generated from the JavaScript file.
 								//  Attention:  In case of local files, the browser has to
 								// Commandline  Parameters:  " allow-file-access-from-files  started
 								//.  Otherwise start under a webserver.
 								//
 								w =  new Worker (background_worker.js)  ;
								
 							//  Background Worker not terminated ...
 							} else {
 								//  This is where the Bachground Worker is active
 							}		
 							//  Event  Message Que through which all the data from the WebWorker arrives.
 							//
 							w.onmessage  = function   (event)   {
							
 								workData  =  event.data.split (~)  ;
 								// ... then run through the array workData with the key= value Couples  ...
 								//  ... then run through the array workData with the key =value pairs ...
 								for (idx in workData)  {
 									//  ...  and split them according to the separator  "="  and put them in the array
 									// splitData ab.  In index 0 = key and index  1 = Data ...
 									//  ...   and split them using the separator  =  and put them in the array
 									// splitData ab.   In index 0 =  key and index   1 = Data ...
 									splitData  =  workData[idx].split (=)  ;
 									//  ... look now for the values of the keys ...
 									//  ... here the Julian date of the new moon and the darkness
 									// ... look now for the values of the keys ...
 									//  ...   here the Julian date of the new moon and the darkness
 									if (splitData[0]  = =  longitude)  {
 										  =  splitData[1];
 									}else if (splitData[0]  = =  magnitude)  {
 										mg  =  splitData[1];
 									}

 								}// End of for  (....)
								
 							}// End of onmessage ()
							
 						//  The browser does not know the WebWorker and displays an error message.
 						}  else  {
 							alert (Sorry, your browser does not support multitasking with webworker ... ") ;
 						}
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

  It is also very important to know that the execution of the program on the local hard drive
  does not work that easy.  To do this, the browser must have the following parameter, entered under Objective:
  in the properties of the browser icon on the desktop. 
 
  C:\Program Files (x86) \Google\Chrome\Application\chrome.exe --allow-file-access-from-files
 
  Important is the back part of the link:  --allow-file-access-from-files  this allows the browser to 
  To access files from the hard drive.  This is not necessary when loading from a website.
 
  The Background Worker provides all data of the solar eclipse and sunrise and sunset
  at your disposal.  The data are displayed on request of the main program and the graphical output window
  sent to them syncron so that both receive the data in parallel.
 
 ********************************************************************************************************************************** */

var DELAYCOUNTER = 10;			// Wartezeit fr den Zhler
													// Waiting time for the counter
var splitData = new Array();			// Array nimmt die gespliteten Daten vom HTML Programm auf
													// Array takes the split data from the HTML program
var workData = new Array();		// Array nimmt die einzelnen Werte aus splitData auf
													// Array takes the split data from the splitData array
var magSolar = new Array();		// Ergebnis der solaren Magnitude
													// Result of the solar magnitude
var jdNewMoon = 0.0;					// Julianisches Datum des Neumondes
													// Julian date of the new moon
var occur = "";								// Ereignis des Neumondes von sunMoonEventsOccur()
													// New Moon Event of sunMoonEventsOccur ()
var lo = -180.0;								// Der zu berechnende Lngengrad
													// The degree of longitude to be calculated
var la = -90.0;								// Der zu berechnende Breitengrad
													// The degree of latitude to be calculated
var LASTEP = 0.0;						// Schrittweite der Berechnung des Breitengrades
													// Step range of the calculation of the latitude
var LOSTEP = 0.0;						// Schrittweite der Berechnung des Lngengrades
													// Step range of the calculation of the longitude
var countDegrees = 0;					// Zhler fr die Eingabe der Schrittweite Long + Lat
													//  Counter for entering the step length Long + Lat
var mainCount = 1;						// Anzahl der Berechnungen
													// Number of calculations
var calcEnd = false;						// Abbruch des Background-Workers
													// Aborting the background worker
var countProgressWhole = 0.0;	// Anzahl der Berechnungen gesamt
													// Number of calculations total
var percentProgressWhole = 0.0;	// Prozent der schon verarbeiteten Berechnungen
													// Percentage of calculations already processed
var newMoonDay = 0;					// Neumond Tag
													// New moon day
var newMoonMonth = 0;				// Neumond Month
													// New moon month
var newMoonYear = 0;					// Neumond Jahr
													// New moon year
var sunRize = new Array();			// Ergebnis des Sonnenaufgangs
													// Result of sunrise
var sunSet = new Array();			// Ergebnis des Sonnenuntergangs
													// Result of sunset
var eRS = "";								// Returnstring eines Fehlers beim Sonnenauf- und Untergang
													// Return string of an error at sunrise and sunset
var moonRize = new Array();		// Ergebnis des Mondaufgangs
													// Result of moonrise
var moonSet = new Array();			// Ergebnis des Monduntergangs
													// Result of moonset
var eMoonRS = "";						// Returnstring eines Fehlers beim Mondauf- und Untergang
													// Return string of an error at moonrise and moonset
var sendStrMain = "";					// Sendestring der Daten an das Hauptprogramm
													// Send string of the data to the main program
var sendStrOutput = "";				// Sendestring der Daten an das Grafikfenster
													// Send string of the data to the graphic window
var sendStrMoonOutput = "";		// Sendestring der Monddaten an das Grafikfenster
													// Send string of the moon data to the graphic window
var sendData = false;					// Zeigt an, das Hauptprogramm Daten haben mchte
													// Shows that the main program wants to have data
var sendDataOutput = false;		// Zeigt an, das Grafikfenster Daten haben mchte
													// Shows that the graphic window wants to have data
var UTFIRSTCONTACT = 0.0;		// Universal Time des ersten Kontakts Sonne - Mond
													// Universal Time of first contact Sun  Moon
var UTMAXCONTACT = 0.0;		// Universal Time des mittleren Kontakts Sonne - Mond
													// Universal Time of middle contact Sun  Moon
var UTLASTCONTACT = 0.0;		// Universal Time des letzten Kontakts Sonne - Mond
													// Universal Time of last contact Sun  Moon

// Importiere alle Scripts, die fr die Berechnung der solaren Magnitude
// erforderlich sind ...
//  Import all scripts for calculating the solar magnitude
 // are required ...
 
 //  ************************** Fr Lokale Installation *******************************
importScripts('../../../Bibliotheken/NewFullMoon.js');
importScripts('../../../Bibliotheken/calculateJD.js');
importScripts('../../../Bibliotheken/Utilities.js');
importScripts('../../../Bibliotheken/SunRiseSet.js');
importScripts('../../../Bibliotheken/decTime.js');
importScripts('../../../Bibliotheken/SiderialTime.js');
importScripts('../../../Bibliotheken/Sunpositions.js');
importScripts('../../../Bibliotheken/SunRiseSet.js');
importScripts('../../../Bibliotheken/MoonRiseSet.js');


/*  ************************** Fr Online Installation *******************************

importScripts('../../Bibliotheken/NewFullMoon.js');
importScripts('../../Bibliotheken/calculateJD.js');
importScripts('../../Bibliotheken/Utilities.js');
importScripts('../../Bibliotheken/SunRiseSet.js');
importScripts('../../Bibliotheken/decTime.js');
importScripts('../../Bibliotheken/SiderialTime.js');
importScripts('../../Bibliotheken/Sunpositions.js');
importScripts('../../Bibliotheken/SunRiseSet.js');
importScripts('../../Bibliotheken/MoonRiseSet.js');
*/

// Funktion um alle deklarierten Variablen auf Anfangswerte zu setzen.
// Function  to set all declared variables to initial values.
function resetVariables(){
	DELAYCOUNTER = 10;			// Wartezeit fr den Zhler
													// Waiting time for the counter
	splitData = new Array();			// Array nimmt die gespliteten Daten vom HTML Programm auf
													// Array takes the split data from the HTML program
	workData = new Array();			// Array nimmt die einzelnen Werte aus splitData auf
													// Array takes the split data from the splitData array
	sendDataOutput = false;			// Zeigt an, das Grafikfenster Daten haben mchte
													// Shows that the graphic window wants to have data
	sendData = false;						// Zeigt an, das Hauptprogramm Daten haben mchte
													// Shows that the main program wants to have data
	magSolar = new Array();			// Ergebnis der solaren Magnitude
													// Result of the solar magnitude
	jdNewMoon = 0.0;					// Julianisches Datum des Neumondes
													// Julian date of the new moon
	occur = "";								// Ereignis des Neumondes von sunMoonEventsOccur()
													// New Moon Event of sunMoonEventsOccur ()
	lo = -180.0;								// Der zu berechnende Lngengrad
													// The degree of longitude to be calculated
	la = -90.0;									// Der zu berechnende Breitengrad
													// The degree of latitude to be calculated
	LASTEP = 0.0;							// Schrittweite der Berechnung des Breitengrades
													// Step range of the calculation of the latitude
	LOSTEP = 0.0;							// Schrittweite der Berechnung des Lngengrades
													// Step range of the calculation of the longitude
	countDegrees = 0;					// Zhler fr die Eingabe der Schrittweite Long + Lat
													// Counter for entering the step length Long + Lat
	mainCount = 1;							// Anzahl der Berechnungen
													// Number of calculations
	calcEnd = false;						// Abbruch des Background-Workers
													// Aborting the background worker
	countProgressWhole = 0.0;		// Anzahl der Berechnungen gesamt
													// Number of calculations total
	percentProgressWhole = 0.0;	// Prozent der schon verarbeiteten Berechnungen
													// Percentage of calculations already processed
	newMoonDay = 0;					// Neumond Tag
													// New moon day
	newMoonMonth = 0;					// Neumond Monat
													// New moon month
	newMoonYear = 0;					// Neumond Jahr
													// New moon year
	sunRize = new Array();				// Ergebnis des Sonnenaufgangs
													// Result of sunrise
	sunSet = new Array();				// Ergebnis des Sonnenuntergangs
													// Result of sunset
	moonRize = new Array();			// Ergebnis des Mondaufgangs
													// Result of moonrise
	moonSet = new Array();			// Ergebnis des Monduntergangs
													// Result of sunset
	eRS = "";									// Returnstring eines Fehlers beim Sonnenauf- und Untergang
													// Return string of an error at sunrise and sunset
	eMoonRS = "";							// Returnstring eines Fehlers beim Mondauf- und Untergang
													// Return string of an error at moonrise and moonset
	sendStrMain = "";						// Sendestring der Daten an das Hauptprogramm
													// Send string of the data to the main program
	sendStrOutput = "";					// Sendestring der Daten an das Grafikfenster
													// Send string of the data to the graphic window
	sendStrMoonOutput = "";			// Sendestring der Monddaten an das Grafikfenster
													// Send string of the moon data to the graphic window
	UTFIRSTCONTACT = 0.0;		// Universal Time des ersten Kontakts Sonne - Mond
													// Universal Time of first contact Sun  Moon
	UTMAXCONTACT = 0.0;			// Universal Time des mittleren Kontakts Sonne - Mond
													// Universal Time of middle contact Sun  Moon
	UTLASTCONTACT = 0.0;			// Universal Time des letzten Kontakts Sonne - Mond
													// Universal Time of last contact Sun  Moon
	dialogOpen = undefined;			// Zeigt an ob das Dialogfenster offen ist
													// Shows whether the dialog is open
	goandwork = undefined;			// Zeigt an, ob der Bachgroundworker nach Dialog gestartet werden kann
													// Shows whether the Bachgroundworker can be started after dialog
}// End of resetVariables()


// Erstellt einen neuen Kommunikationskanal ber den die berechneten
// Daten zum grafischen Fenster gesendet werden. Hier die Zeiten des
// Sunrise und Sunset und geografischen Daten ...
// Created  a new communication channel through which the calculated
// Data  be sent to the graphical window.  Here are the times of the
// Sunrise and Sunset and Geographical Data ...
var channelExtern = new BroadcastChannel("comExtern");

// Event Handler der zu empfangenden Daten vom Hauptprogramm und Erstellers des Workers ...
// Event handler of the data to be received from the main program and creator of the worker ...
self.addEventListener( 'message', function (e){
	// Empfngt vom Hauptprogramm die Daten und splitet die key=value Wertepaare,
	// die durch eine "~" getrennt sind auf speichert sie im Array workData ...
	// Receives the data from the main program and splits the key = value pairs,
 	// which are separated by a ~ on stores them in the array workData ...
	workData = e.data.split("~");
	// ... danach durchlaufe das Array workData mit den key=value Paaren ...
	// ... then run through the array workData with the key=value pairs ...
	for(idx in workData){
		// ... und splitte diese anhand des Trenners "=" auf und lege sie im Array
		// splitData ab. Im Index 0 = key und Index 1 = Data ...
		// ...  and split them using the separator = and put them in the array
 		// splitData ab.  In index 0 = key and index  1 = Data ...
		splitData = workData[idx].split("=");
		// ... schaue nun nach den Werten der Key's ...
		// ... hier das Julianische Datum des Neumondes und der Finsternis
		// ... look now for the values of the keys ...
 		// ...  here the Julian date of the new moon and the darkness
		if (splitData[0] == "jdNewMoon"){
			jdNewMoon = splitData[1];
		// ... hier wird die Verarbeitung durch rufen der Funktion calcLongitude()
		// gestartet ...
		//  ... here the processing is done by calling the function calcLongitude () 
 		// started ...
		}else if (splitData[0] == "work"){
			calcLongitude();
		// ... hier wird der Event der Finsternis abgefragt und in der Variablen occur
		// gespeichert. Wird fr die Funktion magSolarEclipse() bentigt ...
		//  ... here the event of the darkness is queried and in the variable occur
 		// saved.  Is required for magSolarEclipse () function ...
		}else if(splitData[0] == "occur"){
			occur = splitData[1];
		// ... nach Bettigung der Stop-Buttons im Hauptprogramm sendet dieses
		// ein Herunterfahren und dies wird in der Variablen calcEnd gespeichert ...
		// ...  after pressing the stop buttons in the main program, the
 		//  a shutdown and this is stored in the variable calcEnd ...
		}else if(splitData[0] == "breakDown"){
			calcEnd = true;
		// ... hier kommt die Schrittweite der Berechnung im Lngengrad und Speichern
		// in der Variablen LOSTEP sowie inkrement der countDegrees, damit die
		// Gesamtanzahl der Berechnungen kalkuliert werden kann ...
		// ... here comes the step width of the calculation in longitude and save
 		// in the variable  LOSTEP as well as increment of the countDegrees so that the
 		// Total number of calculations  can be calculated ...
		}else if(splitData[0] == "longstep"){
			LOSTEP = Number(splitData[1]);
			countDegrees++;
		// ... und hier die Schrittweite des Breitengrades ...
		// ...  and here the step width of the latitude ...
		}else if(splitData[0] == "latstep"){
			LASTEP = Number(splitData[1]);
			countDegrees++;
		// ... hier wird die Wartezeit fr den Aufruf der nchsten Berechnung 
		// vom Hauptprogramm empfangen und in der globalen Variablen
		// DELAYCOUNTER abgelegt und zur Besttigung des Empfangs
		// an das Hauptprogramm zur Ausgabe zurckgegeben ...
		//  ... here is the waiting time for the call of the next calculation 
 		// received from the main program and in the global variable
 		//  DELAYCOUNTER deposited and to confirm receipt
 		// returned to the main program for output ...
		}else if(splitData[0] == "delay"){
			DELAYCOUNTER = Number(splitData[1]);
			self.postMessage("returndelay=" + DELAYCOUNTER);
		// ... hier der Empfang des Neumond Tages und ablegen in 
		// Variable newMoonDay ...
		//  ... here the reception of the New Moon Day and deposit in 
 		// Variable newMoonDay  ...
		}else if(splitData[0] == "newmoonday"){
			newMoonDay = Number(splitData[1]);
		// ... hier der Empfang des Neumond Monats und ablegen in 
		// Variable newMoonMonth ...
		//  ... here the reception of the New Moon month and deposit in 
 		// Variable newMoonMonth  ...
		}else if(splitData[0] == "newmoonmonth"){
			newMoonMonth = Number(splitData[1]);
		// ... hier der Empfang des Neumond Jahres und ablegen in 
		// Variable newMoonYear ...
		//  ... here the reception of the New Moon year and deposit in 
 		// Variable newMoonYear  ...
		}else if(splitData[0] == "newmoonyear"){
			newMoonYear = Number(splitData[1]);
		// Das Hauptprogramm mchte die berechneten Daten gesendet bekommen 
		//  The main program wants to get the calculated data sent
		}else if(splitData[0] == "senddata"){
			sendData = true;
		// Empfngt die UT (Universal Time) des ersten Kontaktes Sonne und Mond
		// Receives  the UT (Universal Time) of the first contact Sun and Moon
		}else if(splitData[0] == "utfirstcontact"){
			UTFIRSTCONTACT = Number(splitData[1]);
		// Empfngt die UT (Universal Time) des maximalen Kontaktes Sonne und Mond
		// Receives  the UT (Universal Time) of the maximal contact Sun and Moon
		}else if(splitData[0] == "utmaxcontact"){
			UTMAXCONTACT = Number(splitData[1]);
		// Empfngt die UT (Universal Time) des letzten Kontaktes Sonne und Mond
		// Receives  the UT (Universal Time) of the last contact Sun and Moon
		}else if(splitData[0] == "utlastcontact"){
			UTLASTCONTACT = Number(splitData[1]);
		// Vom Hauptprogramm kommt die Anfage des grafischen Fensters die
		// berechneten Daten dort hin zu senden ...
		//  From the main program comes the start of the graphical window
 		// to send calculated data there ...
		}else if(splitData[0] == "senddataoutput"){
			sendDataOutput = true;
		}
		// Wenn Lngengrad und Breitengrad empfangen wurde, dann Berechne
		// die Anzahl der kompletten Berechnungen ...
		//  If longitude and latitude were received, then calculate
 		//  the number of complete calculations ...
		if (countDegrees == 2){
			// Anzahl der Gesamtberechnungen ber die Erdkugel kalkulieren.
			// Calculate the number of total calculations over the globe.
			countProgressWhole = (360.0 / LOSTEP) * (180.0 / LASTEP);
			// Zhler dann auf 0 setzen, damit die Berechnung nur einmal gemacht wird.
			// then set the counter to 0 so that the calculation is done only once.
			countDegrees = 0;
		}
		
	}// End of for(...)
	
}, false);


// Die Funktion berechnet immer fr alle Breitengrade eines Lngengrades
// die erforderlichen Daten fr die Finsternis. Dies sind einmal die Bedeckung
// der Sonne durch den Mond als Dezimalwert von 0 - 1. Die Parameter fr den
// Sonnenaufgang und -Untergang. Die dezimalen Uhrzeit an dem Ort der Berchnung.
// Den Status fr Sonnenaufgang und -Untergang - "OK" oder "Immer Sichtbar" oder "Nie
// Sichtbar".
//
// The function always calculates for all latitudes of a longitude
// the necessary data for the darkness.  These are once the covering
// of the Sun by the Moon as a decimal value of 0  1.  The parameters for the
// Sunrise and sunset.  The decimal time at the place of calculation.
// The status for sunrise and sunset  OK or Always Visible or Never
// Visible.
function calcLatitude(){
	// Sendestring, der an das Hauptprogramm gesendet wird auf leer setzen
	// Set the transmission string that is sent to the main program to blank
	sendStrMain = "";
	// Sendestring der Daten an das Grafikfenster auf leer setzen 
	// Send string of the data to the graphic window  set to blank
	sendStrOutput = "";
	// Sendestring der Monddaten an das Grafikfenster auf leer setzen 
	// Send string of the moon data to the graphic window  set to blank
	sendStrMoonOutput = "";
	// Die Bedeckung am Berechnungslngengrad und -Breitengrad berechnen ...
	//  Calculate the coverage at the design longitude and latitude ...
	magSolar = magSolarEclipse(jdNewMoon, lo, la, occur);
	// ... und hier alles ans Hauptprogramm zur Ausgabe senden ...
	// ... der Lngengrad zum String fr das Hauptprogramm liegt in der Variablen lo ...
	//  ... the longtitude of the string for the main program is in the variable lo  ...
	sendStrMain += "longitude=" + lo + "~";
	// ... der Breitengrad zum String fr das Hauptprogramm liegt in der Variablen la ...
	//  ... the latitude of the string for the main program is in the variable la  ...
	sendStrMain += "latitude=" + la + "~";
	// ... die Bedeckung zum String fr das Hauptprogramm liegt im Array magSolar mit Index 0 ...
	//  ... the covering of the string for the main program is in the array magSolar with index 0 ...
	sendStrMain += "magnitude=" + magSolar[0] + "~";
	// Sonnenaufgang und Sonnenuntergang mit den Returnwerten berechnen ...
	// 		RET[0]		=	Der Sonnenaufgang in Dezimaler Form und Number
	//		RET[1]		=	Status der Konvertierung von GST nach UT. Werte sind "Warnung" + "OK"
	//		RET[2]		=	Status des Sonnenaufgangs . Werte sind "OK",
	//							"Nie Sichtbar" und "Immer Sichtbar" ...
	// ... Sonnenaufgang berechnen ...
	//
	// Calculate sunrise and sunset with the return values ...
 	// 		 RET[0]		 =	 The Sunrise in Decimal Form and Number
 	//		 RET[1]		 =	 Convert status from GST to UT.  Values are Warning + OK
 	//		 RET[2]		 =	 Status of sunrise .  Values are OK,
 	//							 Never Visible and Always Visible ...
 	//  ... Calculate sunrise ...
	sunRize = sunriseLocalTime(newMoonDay, newMoonMonth, newMoonYear, 1, Math.ceil(lo / 15.0), lo, la);
	// ... Sonnenuntergang berechnen, Returndaten wie oben ...
	//  ... Calculate sunset, return data as above ...
	sunSet = sunsetLocalTime(newMoonDay, newMoonMonth, newMoonYear, 1, Math.ceil(lo / 15.0), lo, la);
	// ... und den Status der Auf- und Untergangs zu dem Datum, DST, TZ und an dem Ort ...
	//eRS = eSunRS(newMoonDay, newMoonMonth, newMoonYear, 1, Math.ceil(lo / 15.0), lo, la);
	
	// Mondaufgang und Monduntergang mit den Returnwerten berechnen ...
	//		RET[0] ist der Mondaufgang in Dezimaler Form als String
	//		RET[1] ist der Status der Konvertierung GST zu UT als String
	//		RET[2] ist der Status des Mondaufganges als String
	//		RET[3 - 5] Tag, Monat und Jahr des Mondaufgangs
 	//  ... Calculate moonrise ...
	//		RET[0] is the moonrise in decimal form as string
	//		RET[1] the status of the conversion is GST to UT as string
	//		RET[2] the state of the moon rise is as string
	//		RET[3 - 5] Day, month and year of moon rise
	moonRize = moonriseLocalTime(newMoonDay, newMoonMonth, newMoonYear, 1, Math.ceil(lo / 15.0), lo, la);
	// ... und hier Mond Aufgangsdaten fr das grafisches Ausgabefenster zusammenstellen ...
	//  ... compile the moon rise data for the graphic window ...
	sendStrMoonOutput += "~moonrise=" + moonRize[0] + "~moonrisegst2ut=" + moonRize[1] + "~moonrisestate=" + moonRize[2] +
										"~moonriseday=" + moonRize[3] + "~moonrisemonth=" + moonRize[4] + "~moonriseyear=" + moonRize[5] ;
	// ... Monduntergang berechnen, Returndaten wie oben ...
	//  ... Calculate moonset, return data as above ...
	moonSet = moonsetLocalTime(newMoonDay, newMoonMonth, newMoonYear, 1, Math.ceil(lo / 15.0), lo, la);
	// ... und hier Mond Untergangsdaten fr das grafisches Ausgabefenster zusammenstellen ...
	//  ... compile the moon set data for the graphic window ...
	sendStrMoonOutput += "~moonset=" + moonSet[0] + "~moonsetgst2ut=" + moonSet[1] + "~moonsetstate=" + moonSet[2] +
										"~moonsetday=" + moonSet[3] + "~moonsetmonth=" + moonSet[4] + "~moonsetyear=" + moonSet[5] ;;
	// ... und den Status der Auf- und Untergangs zu dem Datum, DST, TZ und an dem Ort ...
	++mainCount;	
	// ... und hier Daten fr das Hauptprogramm zusammenstellen ...
	//  ... compile the data for the main program ...
	sendStrMain += "percentProgress=" + (mainCount / countProgressWhole);
	// ... und hier Daten fr das grafisches Ausgabefenster zusammenstellen ...
	//  ... compile the data for the graphic window ...
	sendStrOutput += sendStrMain + "~" + "newmoonday=" + newMoonDay + "~" + 
								"newmoonmonth=" + newMoonMonth + "~" + "newmoonyear=" + newMoonYear + "~" +
								"steplat="  + LASTEP + "~" + "steplong=" + LOSTEP + "~" + "utfirstcontact=" + UTFIRSTCONTACT + "~" +
								"utmaxcontact=" + UTMAXCONTACT + "~" + "utlastcontact=" + UTLASTCONTACT + "~";
	// ... Sendedaten fr das Grafikfenster erweitern ...
	//  ... compile the data for the graphic window and extend ...
	sendStrOutput = sendStrOutput + "risetime=" + sunRize[0] + "~" + "risegst2ut=" + sunRize[1] + "~" + "risestate=" + sunRize[2] + "~" +
								"settime=" + sunSet[0] + "~" + "setgst2ut=" + sunSet[1] + "~" + "setstate=" + sunSet[2] + "~" +
								"longitude=" + lo + "~" + "latitude=" + la + "~" + "magnitude=" + magSolar[0];
	sendStrOutput = sendStrOutput + sendStrMoonOutput;
	//console.log(sendStrOutput + "\n");
	// ... hier muss jetzt gewartet werden bis vom Hauptprogramm Daten angefordert werden ...
	// der Fall, wenn sendData = true und dann senden ...
	//  ... here you have to wait until data is requested from the main program ...
 	// the case , if sendDataOutput = true and then send  ...
	
	// ... hier muss jetzt gewartet werden bis vom Grafikfenster Daten angefordert werden ...
	// der Fall, wenn sendDataOutput = true und dann senden ...
	//  ... here you have to wait until data is requested from the graphic window ...
 	// the case , if sendDataOutput = true and then send  ...
	if ( (sendData == true) && (sendDataOutput == true) ) {
		// ... an das Hauptprogramm ...
		// ... to main program ...
		self.postMessage(sendStrMain);
		// ...und Variable auf Empfang setzen ...
		// ... and set variable to receive data ...
		sendData = false;
		// ... an das Grafikfenster ...
		// ... to grafic window ...
		channelExtern.postMessage(sendStrOutput);
		// ...und Variable auf Empfang setzen ...
		// ... and set variable to receive data ...
		sendDataOutput = false;
	}
	// ... wenn der Breitengrad von 90.0  noch nicht erreicht ist und die Daten 
	// an das Hauptprogramm und das Grafikfenster gesendet wurden, die Funktion calcLongitude
	// mit Wartezeit aufrufen. Wartezeit, damit die Programme die empfangenen Daten verarbeiten
	// knnen. Dies wird durch Handshaking gewhrleistet ...
	//  ... if the latitude of 90.0  is not yet reached and the data 
 	// have been sent to the main program and the graphic window, the function  calcLongitude
 	// with wait time.  Waiting time for the programs to process the received data
 	// can.  This is ensured by handshaking ...
	if ( (la < 90.0) && (sendData == false) && (sendDataOutput == false) ) {
		// ... Breitengrad um n Grad erhhen ...
		//  ... increase latitude by n degrees ...
		la += LASTEP;
		// .. und Timeout fr die Funktion calcLatitude() setzen, damit die Daten im
		// Hauptprogramm und Grafikfenster angezeigt und verarbeitet werden knnen ...
		self.setTimeout("calcLatitude()", DELAYCOUNTER);
	// ... wenn der Lngengrad von 180.0  noch nicht erreicht ist und die Daten 
	// an das Hauptprogramm und das Grafikfenster gesendet wurden, die Funktion calcLongitude
	// mit Wartezeit aufrufen. Wartezeit, damit die Programme die empfangenen Daten verarbeiten
	// knnen. Dies wird durch Handshaking gewhrleistet ...
	}else if ( (lo < 180.0) && (sendData == false) && (sendDataOutput == false) ){
		// ... Lngengrad um n Grad erhhen ...
		//  ... increase longitude by n degrees ...
		lo += LOSTEP;
		// .. und Timeout fr die Funktion calcLongitude() setzen, damit die Daten im
		// Hauptprogramm und Grafikfenster angezeigt und verarbeitet werden knnen ...
		// .. und Timeout fr die Funktion calcLongitude() setzen, damit die Daten im
		// Hauptprogramm und Grafikfenster angezeigt und verarbeitet werden knnen ...
		self.setTimeout("calcLongitude()", DELAYCOUNTER);
	}
	
}// End of calcLatitude()


// Die Funktion zur Berechnung der solaren Magnitude und der Sonnenaufgangs-
// und Untergangsparameter quasi als ussere Schleife ...
//  The function for calculating the solar magnitude and the sunrise
 // and sinking parameters as an outer loop ...
function calcLongitude() {
	// ... Berechnungsende wurde durch Klick auf den "Stop" Button im Hauptprogramm
	// angefordert ...
	//  ... Calculation ended by clicking on the Stop button in the main program
 	// requested ...
	if (self.calcEnd == true) {
		// ... Nachricht an das Hauptprogramm zur Ausgabe der Anzahl der Berechnungen ...
		//  ... Message to the main program to output the number of calculations ...
		self.postMessage("maincount=" + mainCount);
		// ... und das Unterbrochen wurde zurck ans Hauptprogramm ...
		// ...  and the interruption was back to the main program ...
		self.postMessage("break=true" );
		// ... sowie alle Variablen zurcksetzen ...
		// ... and reset all variables ...
		resetVariables();
	}
	// Solange bis der Lngengrad von 180 erreicht ist die Funktionen
	// rekursiv aufrufen
	//  Until the longitude of 180 is reached, the functions
 	//  call recursively
	if ( lo < 180.0){
		// ... fr den nchsten Lngengrad setze den Breitengrad wieder auf -90  ...
		//  ... for the next degree of longitude set the latitude back to -90  ...
		la = -90.0 + LASTEP;
		// ... Ergebnisarray fr die Bedeckung und Finsterniszeiten leeren ...
		//  ... empty result array for magnitude and eclipse ...
		magSolar = [];
		// ... Ergebnisarray fr den Sonnenaufgang leeren ...
		//  ... empty result array for sunrise ...
		sunRise = [];
		// ... Ergebnisarray fr den Sonnenuntergang leeren ...
		//  ... empty result array for sunset ...
		sunSet = [];
		// ... und fr jeden Breitengrad am aktuellen Lngengrad die Berechnungen
		// nach Wartezeit durchfhren ...
		// ... and for each latitude at the current longitude
 		// execute after timeout ...
		self.setTimeout("calcLatitude()", DELAYCOUNTER);
	// Programm durchgelaufen und beendet ...
	// Programme  gone through and finished ...
	}else{
		// ... bei Berechnungsende die Anzahl der Berechnungen an das Hauptprogramm melden ...
		// ... at the end of the calculation report the number of calculations to the main program ...
		self.postMessage("maincount=" + mainCount);
	}
	
}// End of calcLongitude()
